#include "main.h"

using namespace std;

//****************************************************
// Global Variables
//****************************************************
Scene *scene;
UCB::ImageSaver * imgSaver;

int frameCount = 0;

/* The recursive render function.  
 Note: This is the only function you need to edit for this assignment! 
 (but feel free to edit anything you'd like to.) */
BoundingBox RenderInstance(SceneInstance *n, vec3 color, int lod)
{
    IMPLEMENT_ME(__FILE__,__LINE__);
    return BoundingBox();
}


//-------------------------------------------------------------------------------
/// You will be calling all of your drawing-related code from this function.
/// Nowhere else in your code should you use glBegin(...) and glEnd() except code
/// called from this method.
///
/// To force a redraw of the screen (eg. after mouse events or the like) simply call
/// glutPostRedisplay();
void display() {

	//Clear Buffers
    glClear(GL_COLOR_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);					// indicate we are specifying camera transformations
	glLoadIdentity();							// make sure transformation is "zero'd"

    RenderInstance(scene->getRoot(), vec3(1,1,1), 3); // render at solid LOD

	//Now that we've drawn on the buffer, swap the drawing buffer and the displaying buffer.
	glutSwapBuffers();

}


//-------------------------------------------------------------------------------
/// \brief	Called when the screen gets resized.
/// This gives you the opportunity to set up all the relevant transforms.
///
void reshape(int w, int h) {
	//Set up the viewport to ignore any size change.
	glViewport(0,0,w,h);

	//Set up the PROJECTION transformationstack to be a simple orthographic [-1, +1] projection
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    if (w < h)
	    glOrtho(-20, 20, -h*20/float(w), h*20/float(w), 1, -1);	// resize type = stretch
    else
        glOrtho(-w*20/float(h), w*20/float(h), -20, 20, 1, -1);	// resize type = stretch

	//Set the MODELVIEW transformation stack to the identity.
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}


//-------------------------------------------------------------------------------
/// Called to handle keyboard events.
void myKeyboardFunc (unsigned char key, int x, int y) {
	switch (key) {
		case 27:			// Escape key
			exit(0);
			break;
	}
}

//-------------------------------------------------------------------------------
/// Called to update the screen at 30 fps.
void frameTimer(int value){

    frameCount++;
    glutPostRedisplay();
    glutTimerFunc(1000/30, frameTimer, 1);
}


//-------------------------------------------------------------------------------
/// Initialize the environment
int main(int argc,char** argv) {
	//Initialize OpenGL
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA);

	//Here we load a scene from a scene file.
	if (argc < 2) {
	    cout << "USAGE: show scene.scd" << endl;
	    exit(1);
	}
    scene = new Scene(argv[1]);

	//Initialize the screen capture class to save BMP captures
	//in the current directory, with the prefix "output"
	imgSaver = new UCB::ImageSaver("./", "output");

	//Create OpenGL Window
	glutInitWindowSize(600,600);
	glutInitWindowPosition(0,0);
	glutCreateWindow("CS184 Framework");

	//Register event handlers with OpenGL.
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutKeyboardFunc(myKeyboardFunc);

    frameTimer(0);

	//And Go!
	glutMainLoop();
}
